#!/usr/bin/python2.2
"""HTML Diff: http://www.aaronsw.com/2002/diff
Rough code, badly documented. Send me comments and patches."""

__author__ = 'Aaron Swartz <me@aaronsw.com>'
__copyright__ = '(C) 2003 Aaron Swartz. GNU GPL 2.'
__version__ = '0.2'

import difflib, string

def isTag(x): return x[0] == "<" and x[-1] == ">"

def textDiff(a, b):
    """Takes in strings a and b and returns a human-readable HTML diff."""
    out = []
    a, b = html2list(a), html2list(b)
    s = difflib.SequenceMatcher(isTag, a, b)
    for e in s.get_opcodes():
        delstart = '<font color="maroon" size="-1"><i><strike>'
        delend = '</strike></i></font>'
        insstart = '<font color="#008000">'
        insend = '</font>'
        if e[0] == "replace":
            # @@ need to do something more complicated here
            # call textDiff but not for html, but for some html... ugh
            # gonna cop-out for now
            out.append(delstart + ''.join(a[e[1]:e[2]]) + delend + \
                       insstart + ''.join(b[e[3]:e[4]])+ insend)
        elif e[0] == "delete":
            out.append(delstart + ''.join(a[e[1]:e[2]]) + delend)
        elif e[0] == "insert":
            out.append(insstart +''.join(b[e[3]:e[4]]) + insend)
        elif e[0] == "equal":
            out.append(''.join(b[e[3]:e[4]]))
        else: 
            raise "Um, something's broken. I didn't expect a '" + `e[0]` + "'."
    return ''.join(out)

def html2list(x, b=0):
    mode = 'char'
    cur = ''
    out = []
    for c in x:
        if mode == 'tag':
            if c == '>': 
                if b: cur += ']'
                else: cur += c
                out.append(cur); cur = ''; mode = 'char'
            else: cur += c
        elif mode == 'char':
            if c == '<': 
                out.append(cur)
                if b: cur = '['
                else: cur = c
                mode = 'tag'
            elif c in string.whitespace: out.append(cur+c); cur = ''
            else: cur += c
    out.append(cur)
    return filter(lambda x: x is not '', out)

if __name__=="__main__":
    print textDiff("""<h5>importchecker</h5>A tool to check for unused imports in python source code.<br /><br /><b>link</b>: <a href="http://www.vex.net/parnassus/apyllo.py?i=64234219">http://www.vex.net/p...apyllo.py?i=64234219</a><br />""",
                   """<h5>importchecker</h5>NEW A tool to check for unused imports in python source code.<br /><br /><b>link</b>: <a href="http://www.vex.net/parnassus/apyllo.py?i=64234219">http://www.vex.net/p...apyllo.py?i=64234219</a><br />""")