%define name    pears
%define version 1.7
%define release 1
%define prefix  %{_prefix}

#  get python lib directory
%define pythonpath /usr/bin/python
%define pylibdir %(%{pythonpath} -c "import sys; print '%s/lib/python%s' % (sys.prefix, sys.version[:3])")

#################################
#  End of user-modifiable configs
#################################

Summary:      A fruity RSS aggregator
Name:         %{name}
Version:      %{version}
Release:      %{release}
Copyright:    GPL
Group:        Applications
URL:	      http://come.to/project5

Source:       %{name}-%{version}.tar.gz
Distribution: KRUD
Packager:     Sean Reifschneider <jafo-rpms@tummy.com>

Requires:     python
Requires:     wxPythonGTK
BuildRequires: python
BuildRequires: wxPythonGTK
BuildRoot:    /var/tmp/%{name}-root
BuildArch:    noarch

%description
Pears is a three-pane newsfeed (RSS/RDF) aggregator. It has a clean,
uncluttered interface, it's easy to use and works on Windows, Linux
and MacOSX.

Pears has the following features:
    * caching of downloaded items, with cache size configurable per
      feed
    * read/unread management and deletion capabilities on a per feed,
      per topic or overall basis
    * automatic and quite frequent saving of downloaded data so
      hopefully nothing will ever be lost
    * regular auto-updating, configurable per feed
    * ability to display changes in updated items
    * shortcut key access to most functions, but also mouse-driven
      operation (right-click to update a feed, right-click to toggle
      read/unread status for a topic in a feed) and automatic
      read/unread toggling
    * stores everything in plain text (as Python data structures, no
      registry use under Windows)
    * quite good performance (on my Athlon XP 2000+/512Mb it has no
      problems handling my 2.5 Mb test file - the equivalent of about
      100 quite large feeds or some 500 small ones)
    * all options and downloaded data are stored on a per-user basis.
      In other words, it should be enough to install one copy of 
      Pears on a computer and have that copy be used by different 
      users with different preferences and feeds.
    * just generally well behaved
    * no ads, no nags, free and open source (GPL)

%prep
pwd
rm -rf pears
mkdir pears
cd pears
tar xfz %{SOURCE0}
%setup -D -T -n pears
%build

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"
mkdir -p "$RPM_BUILD_ROOT"/usr/bin
mkdir -p "$RPM_BUILD_ROOT"/%{pylibdir}/site-packages/pears

#  make bin file
echo '#!/bin/sh' >"$RPM_BUILD_ROOT"/usr/bin/pears
echo "%{pythonpath} %{pylibdir}/site-packages/pears/pears.py" >>"$RPM_BUILD_ROOT"/usr/bin/pears
chmod 755 "$RPM_BUILD_ROOT"/usr/bin/pears

#  copy over files
cp *.py "$RPM_BUILD_ROOT"/%{pylibdir}/site-packages/pears/

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"

%files
%defattr(755,root,root)
%doc docs readme.txt about.html.dat
/usr/bin/pears
%{pylibdir}/site-packages/pears/
