#!/usr/bin/env python

"""pearsplugin 1.7 - plugin framework

A real plugin file must have a name ending in '.pear', otherwise
it will not even be recognized. Make sure that you give your file
a name which is very likely to be unique.

Copyright (C) 2003, 2004 Project 5

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Contact info
web: http://come.to/project5
mail/msn: project5@wanadoo.nl
icq: 84243714
jabber: project5@rhymbox.com
"""

class BasePlugin(object):
    """Plugin parent class. 
       Override the run() method to provide useful behavior."""
    def __init__(self):
        """Initialization code."""
    def run(self):
        """This is the method which should contain the actual code.
           A plugin object will be created based on this class and
           its run() method will be executed inside the main window.
           From this method you have access to everything in Pears."""
        print 
        print mw # mw is the main window
        print engine # engine is the Pears engine
        print len(engine.feeds) # engine.feeds is the list of feeds
        print len(engine.items.keys()) # engine.items is a dictionary of news items

# Below is the text used for plugin definition (you are allowed
# to put it anywhere in the file though, as long as it forms
# a consecutive, monolithic block). Note that 
# the plugin info is read from this text, not from the code
# itself since the code is NOT executed when the plugins list
# is built.
# The contents are case and whitespace sensitive, so be careful.
# Everything is regarded as string.

# There are two ways of defining plugins inside a plugin module:
# either that module contains a single plugin, or it contains
# a collection of plugins (which will all be shown together as
# submenuitems of a master menu item). It is not allowed to use
# both methods in the same file (it is possible, but the 
# behavior of Pears in this case is undefined).

# For an individual plugin, use the text below (Class specifies
# the plugin class you defined elsewhere in this same file):
### PEARSPLUGIN
### LongName=Full plugin name, like This is my first plugin
### ShortName=Name shown in the menu, like FirstPlugin
### Hint=Hint shown when the mouse hovers over the menu item
### Version=1.0 demo
### Author=Your Name
### Class=BasePlugin
### END

# For a collection of plugins, use this:
### PEARSPLUGINCOLLECTION
### LongName=Full name of this collection
### ShortName=Short name of the collection shown in the menu
### Hint=Hint shown when the mouse hovers over the collection menu item
### Version=1.0 collection
### Author=Your Name
### 0.ShortName=Name of first plugin in collection
### 0.Hint=Hint for first plugin
### 0.Class=FirstPluginClass
### 1.ShortName=Name of second plugin
### 1.Hint=Hint of second plugin
### 1.Class=SecondPluginClass
### 2.ShortName=Name of third plugin
### 2.Hint=Hint of vplugin
### 2.Class=ThirdPluginClass
# etcetera for all available plugins
### END

# Note that this layout is very, very strict. The items must be specified
# in the required order, there must be no empty lines and in the case
# of the number of the plugins inside a collection, there must be at least
# one plugin in the collection and the plugin numbers inside a start at 0
# and increase up to however many there are, without skipping numbers.
# You are responsible for the integrity of the plugins file;
# the behavior for e.g. if both a PEARSPLUGIN and a PEARSPLUGINCOLLECTION
# are present in the same file or if you specify wrong Class names or
# whatever is not defined. Things may work or they may not work and if
# they work now, they may break in the future if the file is not correct.
