; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Pears"
!define PRODUCT_VERSION "1.7"
!define PRODUCT_PUBLISHER "Project 5"
!define PRODUCT_WEB_SITE "http://come.to/project5"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

SetCompressor lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico" ;"pearsmany.ico" ;
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico" ;"pearsmany.ico" ;

; Welcome page
!define MUI_WELCOMEFINISHPAGE_BITMAP "..\pearssetup.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "..\pearssetup.bmp"
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "licence.txt"
; Components page
;!define MUI_COMPONENTSPAGE_SMALLDESC
;!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "Pears"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\Pears for Windows.bat"
!define MUI_FINISHPAGE_RUN_NOTCHECKED
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\docs\index.html"
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED

!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "I:\Pears\builds\pearssetup-1.7.exe"
InstallDir "$PROGRAMFILES\Pears"
ShowInstDetails show
ShowUnInstDetails show

Section "-Pears" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "about.html.dat"
  File "cleanup.bat"
  File "EmbeddedHTTPServer.py"
  File "feedparser.py"
  File "future.py"
  File "hamsterengine.py"
  File "history.txt"
  File "htmldiff.py"
  File "licence.txt"
  File "Pears for Windows.bat"
  File "pears.py"
  File "pears.spec"
  File "pears.wxg"
  File "pearsapp.py"
  File "pearsconstants.py"
  File "pearsengine.py"
  File "pearsgui.py"
  File "pearsplugin.py"
  File "pearssetup.nsi"
  File "PersistentDict.py"
  File "readme.txt"
  File "rebuildfeeds.py"
  File "ServerMixin.py"
  File "timeoutsocket.py"
  File "pears.ico"
  File "pears.jpg"
  File "pearssmall.ico"
  File "pearsmany.ico"
  SetOutPath "$INSTDIR\plugins"
  SetOutPath "$INSTDIR"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Pears.lnk" "$INSTDIR\Pears for Windows.bat" "" "$INSTDIR\pearsmany.ico"
  CreateShortCut "$QUICKLAUNCH\Pears.lnk" "$INSTDIR\Pears for Windows.bat" "" "$INSTDIR\pearsmany.ico"
SectionEnd

Section "-Library" SEC02
  SetOutPath "$INSTDIR\library"
  File "library\pears.opml"
  SetOutPath "$INSTDIR"
SectionEnd

Section "-Docs" SEC03
  SetOutPath "$INSTDIR\docs"
  File "docs\licence.html"
  File "docs\using.html"
  File "docs\index.html"
  File "docs\faq.html"
  File "docs\plugins.html"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Docs.lnk" "$INSTDIR\docs\index.html"
  SetOutPath "$INSTDIR\docs\dat"
  File "docs\dat\logo.png"
  File "docs\dat\pythonpowered.png"
  File "docs\dat\smile.png"
  File "docs\dat\styles.css"
  File "docs\dat\validcss.png"
  File "docs\dat\validxhtml.png"
  SetOutPath "$INSTDIR"
SectionEnd

Section "-Plugins" SEC04
  SetOutPath "$INSTDIR\plugins"
  File "plugins\cookme.pear"
  File "plugins\collectiontest.pear"
  File "plugins\__init__.py"
  File "plugins\cookme_recipes.py"
  File "plugins\__init__.pyc"
  SetOutPath "$INSTDIR"
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}" "$ICONS_GROUP"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "Required program files"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Library of feeds in OPML format that you can import into Pears"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} "Pears documentation (HTML format)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC04} "Pears plugins"
!insertmacro MUI_FUNCTION_DESCRIPTION_END


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  ReadRegStr $ICONS_GROUP ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}"
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\about.html.dat"
  Delete "$INSTDIR\cleanup.bat"
  Delete "$INSTDIR\EmbeddedHTTPServer.py"
  Delete "$INSTDIR\feedparser.py"
  Delete "$INSTDIR\future.py"
  Delete "$INSTDIR\hamsterengine.py"
  Delete "$INSTDIR\history.txt"
  Delete "$INSTDIR\htmldiff.py"
  Delete "$INSTDIR\licence.txt"
  Delete "$INSTDIR\Pears for Windows.bat"
  Delete "$INSTDIR\pears.py"
  Delete "$INSTDIR\pears.spec"
  Delete "$INSTDIR\pears.wxg"
  Delete "$INSTDIR\pearsapp.py"
  Delete "$INSTDIR\pearsconstants.py"
  Delete "$INSTDIR\pearsengine.py"
  Delete "$INSTDIR\pearsgui.py"
  Delete "$INSTDIR\pearsplugin.py"
  Delete "$INSTDIR\pearssetup.nsi"
  Delete "$INSTDIR\PersistentDict.py"
  Delete "$INSTDIR\readme.txt"
  Delete "$INSTDIR\rebuildfeeds.py"
  Delete "$INSTDIR\ServerMixin.py"
  Delete "$INSTDIR\timeoutsocket.py"
  Delete "$INSTDIR\pears.ico"
  Delete "$INSTDIR\pears.jpg"
  Delete "$INSTDIR\pearssmall.ico"
  Delete "$INSTDIR\pearsmany.ico"
  Delete "$INSTDIR\library\pears.opml"
  Delete "$INSTDIR\docs\licence.html"
  Delete "$INSTDIR\docs\using.html"
  Delete "$INSTDIR\docs\index.html"
  Delete "$INSTDIR\docs\faq.html"
  Delete "$INSTDIR\docs\plugins.html"
  Delete "$INSTDIR\docs\dat\logo.png"
  Delete "$INSTDIR\docs\dat\pythonpowered.png"
  Delete "$INSTDIR\docs\dat\smile.png"
  Delete "$INSTDIR\docs\dat\styles.css"
  Delete "$INSTDIR\docs\dat\validcss.png"
  Delete "$INSTDIR\docs\dat\validxhtml.png"
  Delete "$INSTDIR\plugins\cookme.pear"
  Delete "$INSTDIR\plugins\collectiontest.pear"
  Delete "$INSTDIR\plugins\__init__.py"
  Delete "$INSTDIR\plugins\cookme_recipes.py"
  Delete "$INSTDIR\plugins\__init__.pyc"
  ; clean up .pyo and .pyc files
  Delete "$INSTDIR\*.pyc"
  Delete "$INSTDIR\*.pyo"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Pears.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Docs.lnk"
  Delete "$QUICKLAUNCH\Pears.lnk"
  Delete "$ICONS_GROUP.lnk"
  Delete "$ICONS_GROUP.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\plugins"
  RMDir "$INSTDIR\library"
  RMDir "$INSTDIR\docs\dat"
  RMDir "$INSTDIR\docs"
  RMDir "$INSTDIR"
  RMDir ""

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  SetAutoClose true
SectionEnd
